
#ifndef SSVD
#define SSVD

#include <gsl/gsl_complex.h>
#include <gsl/gsl_matrix.h>

int ssvd_ssvd_work(gsl_matrix_complex * A, size_t k, size_t l, int n_iter,
        gsl_matrix_complex *U, gsl_matrix_complex *Va, gsl_vector *S);
int ssvd_ssvd(gsl_matrix_complex *A, size_t k, size_t l, size_t n_iter,
        gsl_matrix_complex **U, gsl_matrix_complex **Va, gsl_vector **S);

int ssvd_zgeqrf(gsl_matrix_complex * A, int calculate_Q);
int ssvd_zgesvd(gsl_matrix_complex * A, gsl_matrix_complex * U, gsl_matrix_complex
	   * Va, gsl_vector * S);

int ssvd_random_matrix(gsl_matrix_complex * A, double low, double high);
int ssvd_eigen_matrix(gsl_matrix_complex *A, double scale, double decay_const);

#endif
